#ifndef _ENGINE_H

//// INCLUDE

#include "allegro.h"
#include "gamedefs.h"
#include "tilefunc.h"
#include "images.h"
#include "kb.h"

// PROTOTYPES

void Set_Vars(void);
void Intro(void);
void Outro(void);
void Main_Game_Loop(void);

//// FUNCTIONS

void Intro(void)
{
 allegro_init();
 install_keyboard();
 install_timer();
 set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
 data = load_datafile("data.dat");
 if ((data = load_datafile("data.dat")) == NULL)
  {
   allegro_exit();
   printf("- data.dat missing\n");
   exit(0);
  }
 Load_BMP();
 Set_Vars();
}

void Outro(void)
{
 register INT16 i;
 unload_datafile(data);
 destroy_bitmap(ACTIVE);
 allegro_exit();
 exit(0);
}

void Set_Vars(void)
{
 Redraw_WorldMap(MapX, MapY);
 tileX = -32;
 tileY = -32;
 MapX = 0;
 MapY = 0;
 screenshotNUM = 0;
}

void Main_Game_Loop(void)
{ 
 Load_MAP();
 while(!DONE)
  {
   Kb_Hit();
   Bounds();
   Redraw_WorldMap(MapY, MapX);
   vsync();
   blit(ACTIVE, screen, 0, 0, 0, 0, 640, 480);
  } 
}

#define _GAMEDEFS_H
#endif