#ifndef _TILEFUNC_H

//// INCLUDE

#include <stdio.h>
#include "allegro.h"
#include "gamedefs.h"
#include "images.h"

//// DEFINE

//// STRUCUTRES

//// GLOBALS

//// PROTOTYPES

void Load_BMP(void);
void Load_MAP(void);
void Redraw_WorldMap(INT16 col, INT16 row);
void Bounds(void);

//// FUNCTIONS

void Load_BMP(void)
{
 set_palette(data[0].dat);
 ACTIVE = create_bitmap(704, 544);
 clear(ACTIVE);
}

void Load_MAP(void)
{
 FILE *file;
 file = fopen("world.map", "rb");
 if (!file)
  return;
 fread(&levelMAP, sizeof(levelMAP), 1, file);
 fclose(file);
}

void Redraw_WorldMap(INT16 col, INT16 row)
{
 INT16 i, j, tmpcol = col, tmprow = row;
 
 for(j = 0; j < RC(17); j += 32)
  {
   for(i = 0; i < RC(22); i += 32)
    {
      blit(data[levelMAP[0][tmpcol][tmprow].img].dat, ACTIVE, 0, 0, i+tileX, j+tileY, 40, 40);
      if(levelMAP[1][tmpcol][tmprow].img > 0)
       masked_blit(data[levelMAP[1][tmpcol][tmprow].img].dat, ACTIVE, 0, 0, i+tileX, j+tileY, 40, 40);
     tmprow++;
     if (tmprow > 29)
      tmprow = 0;
    }
   i = 0;
   tmprow = row;
   tmpcol++;
   if (tmpcol > 29)
    tmpcol = 0;
  }
}


/*
   the routine to checc to see if the map values should be changed. There are
   better ways to do this.
*/
void Bounds(void)
{
 register INT16 tmp;
 
 if (tileX < -64)
  {
   MapX++;
   if (MapX > 29)
    MapX = 0;
   tmp = (tileX + 64);
   tileX = (-32 + tmp);
  }  

 if (tileX > 0)
  {
   MapX--;
   if (MapX < 0)
    MapX = 29;
   tmp = (tileX);
   tileX = (-32 + tmp);
  }  

 if (tileY < -64)
  {
   MapY++;
   if (MapY > 29)
    MapY = 0;
   tmp = (tileY + 64);
   tileY = (-32 + tmp);
  }  

 if (tileY > 0)
  {
   MapY--;
   if (MapY < 0)
    MapY = 29;
   tmp = (tileY);
   tileY = (-32 + tmp);
  }  
}

#define _TILEFUNC_H
#endif
